-- Initialization
build = {}

--------------------------------------------------
-- These are settings.
fastbuild = true -- true for turn on fast build
if fastbuild then
	limit = true 		-- true for limiting fast build buildings
	cost_money = false 	-- true for costing money
	upgraded = true		-- true for upgraded buildings
	admin_only = false	-- true for allowing admin to fast build only
end 
if admin_only then admin = {} end -- add your usgn here

--------------------------------------------------
-- These are hooks, nothing to be modified.

if fastbuild then addhook("buildattempt", "_build") end
if limit then
	addhook("join", "_j")
	addhook("objectkill", "_ok")
	addhook("startround", "_st")
end

--------------------------------------------------
-- Change only stuffs inside the table.

buildings = { -- name(Do not change this), limit, price, health, [final building](Do not change this), building type(Do not change this)
[1] = {"Barricade", "999", "300", "150", 1};
[2] = {"Barbed Wire", "999", "500", "300", 2};
[3] = {"Wall I", "999", "1000", "500", "5", 3};
[4] = {"Wall II", "999", "2000", "1000", "5", 4};
[5] = {"Wall III", "999", "3000", "2000", 5};
[6] = {"Gate Field", "999", "1500", "1000", 6};
[7] = {"Dispenser", "5", "5000", "1000", 7};
[8] = {"Turret", "1", "5000", "1000", "12", 8};
[9] = {"Supply", "15", "5000", "1000", "15", 9};
[13] = {"Teleporter Entrance", "3", "3000", "500", 13};
[14] = {"Teleporter Exit", "3", "3000", "500", 14};
}

if upgraded and cost_money then for i = 3, 4 do buildings[i][3] = "3000" end end

for _, func in pairs(buildings) do
    parse ('mp_building_limit "'..func[1]..'" '..func[2])
    parse ('mp_building_price "'..func[1]..'" '..func[3])
    parse ('mp_building_health "'..func[1]..'" '..func[4])
end

--------------------------------------------------
-- These are main code.

function initbuildlimit(p)
	if limit then build[p] = {}
	for _, b in pairs(buildings) do build[p][b[#b]] = tonumber(b[2]) end end
end

if fastbuild then function _j(p)
	initbuildlimit(p)
end
end

if limit then function _st()
	for _, p in pairs(player(0, "table")) do
		initbuildlimit(p)
	end
end
end

if admin_only then function req_adm(p)
	for _, i in ipairs(admin) do
		if player(p, "usgn") == i then return true end
	end
	return false
end
end

if fastbuild then function _build(p, t, x, y, m)
	if t == 20 or t == 21 then return 0 end
	if limit and build[p][t] == 0 then msg2(p, "\169255000000You cannot build this type of building any more!") return 1 end
	if limit then build[p][t] = build[p][t] - 1 end
	if admin_only and req_adm(p) == false then return 0 end
	if cost_money then local money = player(p, "money")
	if money < tonumber(buildings[t][3]) then msg2(p, "\169255000000You have insufficient funds.@C") return 1 end
	local money = player(p, "money") - buildings[t][3]
	parse ("setmoney "..p.." "..money) end
    if not upgraded then
        parse ("spawnobject "..t.." "..x.." "..y.." 0 "..m.." "..player(p, "team").." "..p) 
	else
        parse ("spawnobject "..buildings[t][5].." "..x.." "..y.." 0 "..m.." "..player(p, "team").." "..p) 
    end
	return 1
    end
end

if limit then function _ok(i)
	if object(i, "type") ~= 11 and object(i, "type") ~= 12 and object(i, "type") ~= 15 then
		build[object(i, "player")][buildings[object(i, "type")][5]] = build[object(i, "player")][buildings[object(i, "type")][5]] + 1
	elseif object(i, "type") ~= 15 then
		build[object(i, "player")][8] = build[object(i, "player")][8] + 1
	else
		build[object(i, "player")][9] = build[object(i, "player")][9] + 1
	end
end
end
--------------------------------------------------